#ifndef WINDOW_HPP
#define WINDOW_HPP

#include <QGuiApplication>
#include <QMainWindow>
#include <QStandardItemModel>

QT_BEGIN_NAMESPACE
namespace Ui {
class Window;
}
QT_END_NAMESPACE

enum ProtocolStatus {
    UNKNOWN,
    STABLE,
    STAGING,
    UNSTABLE,
    WLROOTS,
};

struct Protocol {
    ProtocolStatus status;
    std::string pretty;
    std::string name;
};

class Window : public QMainWindow {
    Q_OBJECT
    QStandardItemModel model;

  public:
    Window(QNativeInterface::QWaylandApplication* waylandApp, QWidget* parent = nullptr);
    ~Window();

    void newGlobal(const std::string interface, const uint32_t version);

    void addProtocol(const Protocol& protocol);

  private:
    Ui::Window* ui;
};
#endif
